
CoCoALib - Bug #2

Makefile problem in ROOT and/or src/AlgebraicCore

17 Oct 2011 14:55 - Anna Maria Bigatti

Status: Closed Start date: 17 Oct 2011

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Makefile Estimated time: 1.99 hour

Target version: CoCoALib-0.99700 Spent time: 2.05 hours

Description

make clean; make -j2 check

The commands above create the library twice.

Find out why, and rectify.   

Does it happen on all platforms?

History

#1 - 08 Nov 2011 10:05 - Anna Maria Bigatti

- Category set to Makefile

- % Done changed from 0 to 10

#2 - 01 Apr 2014 17:35 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99533 Easter14

#3 - 03 Apr 2014 18:18 - John Abbott

The problem still happens; it's not serious as everything works fine anyway.

I checked on MacOSX 10.5.8.

#4 - 03 Apr 2014 18:19 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#5 - 17 Jul 2014 14:25 - John Abbott

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-1.0

#6 - 28 Jul 2014 21:42 - John Abbott

- Status changed from New to In Progress

- % Done changed from 10 to 20

Almost certainly part of the problem is that ar ru on Mac OS X updates the mtime of the archive even when the archive does not change -- yet another

intelligent Apple design decision... grrrrr!

#7 - 27 Jan 2020 17:55 - John Abbott

- Status changed from In Progress to Resolved

- Assignee set to John Abbott

- % Done changed from 20 to 80

- Estimated time set to 1.55 h
It still happens -- in a sense.

It is not really harmful; just a bit annoying.

If I do make lib then it compiles the library just once (and prints "Compilation of CoCoALib completed").

If I run make lib a second time, it simply prints out "CoCoALib already compiled".

Aha!  If I do make check after having already compiled the library, it prints out CoCoALib already compiled twice.  (clue city?)

If I do make cocoa5 after having already compiled the library, it prints out CoCoALib already compiled just once.  (good!)

Also make examples prints out "already compiled" just once; so I must have messed up mildly with the test suite.

#8 - 27 Jan 2020 17:55 - John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99700

#9 - 12 Feb 2020 14:46 - John Abbott

- Estimated time changed from 1.55 h to 1.99 h

Here is a bad idea: in the root Makefile I simply removed the dependency of check on library.  This does not work because make veryclean;

./configure; make check complains that CoCoA/library.H does not exist.

A possible solution is to declare a dependency of check on dependencies (which in turn triggers the creation of library.H

Alternatively, we can just accept that the message is printed out twice...

#10 - 12 Feb 2020 15:00 - John Abbott

- Status changed from Resolved to Closed

- % Done changed from 80 to 100

I have rearranged the root Makefile: there is a new phony target before-compiling which builds include/CoCoA/library.H and all dependency files.  This

new target is now a pre-requisite for check (instead of library).
